﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Threading;
using Infragistics.Windows.Chart;

namespace ChartTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        double maxWidth = 0;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void ContentPresenter_Loaded(object sender, RoutedEventArgs e)
        {
            try
            {

                foreach (UIElement elem in (((ContentPresenter)sender).Content as Panel).Children)
                {
                    string s = "";

                    if (elem is ContentControl)
                    {
                        s = ((elem as ContentControl).Content as LegendItemTemplate).Text;

                        FormattedText formated =
                                new FormattedText(
                                    s,
                                    Thread.CurrentThread.CurrentCulture,
                                    FlowDirection.LeftToRight,
                                    new Typeface("Segoe UI"),
                                    12,
                                    Brushes.Black);

                        if (maxWidth < formated.Width)
                        {
                            maxWidth = formated.Width;
                        }
                    }
                }

                (sender as ContentPresenter).Width = maxWidth + 11;
                (sender as ContentPresenter).Height = mainChart.Series.Count * 20;
            }
            catch (Exception)
            { }
        }
    }
}
